gdaladdo(1)

NAME
gdaladdo - Builds or rebuilds overview images.

SYNOPSIS

gdaladdo [-r {nearest,average,gauss,cubic,cubicspline,lanczos,average_mp,average_magphase,mode}]
         [-b band]* [-minsize val]
         [-ro] [-clean] [-oo NAME=VALUE]* [--help-general] filename [levels]

DESCRIPTION

The gdaladdo utility can be used to build or rebuild overview images for most supported file formats with one of several downsampling algorithms.

-r {nearest (default),average,gauss,cubic,cubicspline,lanczos,average_mp,average_magphase,mode}:
    Select a resampling algorithm.

-b band:
    (available from GDAL 1.10) Select an input band band for overview generation. Band numbering starts from 1. Multiple -b switches may be used to select a set of input bands to generate overviews.

-ro:
    (available from GDAL 1.6.0) open the dataset in read-only mode, in order to generate external overview (for GeoTIFF especially).

-clean:
    (available from GDAL 1.7.0) remove all overviews.

-oo NAME=VALUE:
    (starting with GDAL 2.0) Dataset open option (format specific)

-minsize val:
    (starting with GDAL 2.3) Maximum width or height of the smallest overview level. Only taken into account if explicit levels are not specified. Defaults to 256.

filename:
    The file to build overviews for (or whose overviews must be removed).

levels:
    A list of integral overview levels to build. Ignored with -clean option. Starting with GDAL 2.3, levels are no longer required to build overviews. In which case, appropriate overview power-of-two factors will be selected until the smallest overview is smaller than the value of the -minsize switch.

Mode (available from GDAL 1.6.0) selects the value which appears most often of all the sampled points. average_mp is unsuitable for use. Average_magphase averages complex data in mag/phase space. Nearest and average are applicable to normal image data. Nearest applies a nearest neighbour (simple sampling) resampler, while average computes the average of all non-NODATA contributing pixels. Cubic resampling (available from GDAL 1.7.0) applies a cubic convolution kernel. Gauss resampling (available from GDAL 1.6.0) applies a Gaussian kernel before computing the overview, which can lead to better results than simple averaging in e.g case of sharp edges with high contrast or noisy patterns. The advised level values should be 2, 4, 8, ... so that a 3x3 resampling Gaussian kernel is selected. CubicSpline resampling (available from GDAL 2.0) applies a B-Spline convolution kernel. Lanczos resampling (available from GDAL 2.0) applies a Lanczos windowed sinc convolution kernel.

gdaladdo will honour properly NODATA_VALUES tuples (special dataset metadata) so that only a given RGB triplet (in case of a RGB image) will be considered as the nodata value and not each value of the triplet independently per band.

Selecting a level value like 2 causes an overview level that is 1/2 the resolution (in each dimension) of the base layer to be computed. If the file has existing overview levels at a level selected, those levels will be recomputed and rewritten in place.

For internal GeoTIFF overviews (or external overviews in GeoTIFF format), note that -clean does not shrink the file. A later run of gdaladdo with overview levels will cause the file to be expanded, rather than reusing the space of the previously deleted overviews. If you just want to change the resampling method on a file that already has overviews computed, you don't need to clean the existing overviews.

Some format drivers do not support overviews at all. Many format drivers store overviews in a secondary file with the extension .ovr that is actually in TIFF format. By default, the GeoTIFF driver stores overviews internally to the file operated on (if it is writable), unless the -ro flag is specified.

Most drivers also support an alternate overview format using Erdas Imagine format. To trigger this use the USE_RRD=YES configuration option. This will place the overviews in an associated .aux file suitable for direct use with Imagine or ArcGIS as well as GDAL applications. (e.g. --config USE_RRD YES)

External overviews in GeoTIFF format

External overviews created in TIFF format may be compressed using the COMPRESS_OVERVIEW configuration option. All compression methods, supported by the GeoTIFF driver, are available here. (e.g. --config COMPRESS_OVERVIEW DEFLATE). The photometric interpretation can be set with --config PHOTOMETRIC_OVERVIEW {RGB,YCBCR,...}, and the interleaving with --config INTERLEAVE_OVERVIEW {PIXEL|BAND}.

For JPEG compressed external overviews, the JPEG quality can be set with '--config JPEG_QUALITY_OVERVIEW value' (GDAL 1.7.0 or later).

For LZW or DEFLATE compressed external overviews, the predictor value can be set with '--config PREDICTOR_OVERVIEW 1|2|3' (GDAL 1.8.0 or later).

To produce the smallest possible JPEG-In-TIFF overviews, you should use :

--config COMPRESS_OVERVIEW JPEG --config PHOTOMETRIC_OVERVIEW YCBCR --config INTERLEAVE_OVERVIEW PIXEL

External overviews can be created in the BigTIFF format by using the BIGTIFF_OVERVIEW configuration option : --config BIGTIFF_OVERVIEW {IF_NEEDED|IF_SAFER|YES|NO}. The default value is IF_SAFER starting with GDAL 2.3.0 (previously was IF_NEEDED). The behaviour of this option is exactly the same as the BIGTIFF creation option documented in the GeoTIFF driver documentation.
•   YES forces BigTIFF.
•   NO forces classic TIFF.
•   IF_NEEDED will only create a BigTIFF if it is clearly needed (uncompressed, and overviews larger than 4GB).
•   IF_SAFER will create BigTIFF if the resulting file might exceed 4GB.
See the documentation of the GeoTIFF driver for further explanations on all those options.

C API
Functionality of this utility can be done from C with GDALBuildOverviews().

EXAMPLE
Create overviews, embedded in the supplied TIFF file, with automatic computation of levels (GDAL 2.3 or later)
gdaladdo -r average abc.tif
Create overviews, embedded in the supplied TIFF file:
gdaladdo -r average abc.tif 2 4 8 16
Create an external compressed GeoTIFF overview file from the ERDAS .IMG file:
gdaladdo -ro --config COMPRESS_OVERVIEW DEFLATE erdas.img 2 4 8 16
Create an external JPEG-compressed GeoTIFF overview file from a 3-band RGB dataset (if the dataset is a writable GeoTIFF, you also need to add the -ro option to force the generation of external overview):
gdaladdo --config COMPRESS_OVERVIEW JPEG --config PHOTOMETRIC_OVERVIEW YCBCR
         --config INTERLEAVE_OVERVIEW PIXEL rgb_dataset.ext 2 4 8 16
Create an Erdas Imagine format overviews for the indicated JPEG file:
gdaladdo --config USE_RRD YES airphoto.jpg 3 9 27 81

AUTHORS
Frank Warmerdam warmerdam@pobox.com, Silke Reimer silke@intevation.de